local UIParent, insert, wipe = UIParent, table.insert, table.wipe;

local PopupWindow = nil
local PopupWindowKey = nil

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CallPopup(Parent, Title, AnchorRef)
    if Parent then 
		local Popup 
		if type(Parent) == "string" then 
			if PopupWindow and PopupWindowKey and PopupWindowKey == Parent then 
				PopupWindowKey = nil
				PopupWindow:Release()
				PopupWindow = nil 				
				return
			else
				PopupWindowKey = Parent
			end
		end
			if Popup then 
				Popup:Release()
				Popup = nil
			end
			Popup = self:CreateWindow(UIParent, Title or "")
			Popup:SetFrameStrata("DIALOG")
			Popup.OnCloseFunc = function() Popup = nil end
			Popup:MakeMovable(true)

			Popup:SetPoint("CENTER", UIParent)

			Popup.Content = self:CreateContainer(Popup)
			Popup.Content:SetPoint("TOPLEFT",Popup.Header,"BOTTOMLEFT",0,-self.Padding)

			Popup:Size(250,20 + 2*self.BorderSize + 3*self.Padding + Popup.Header:GetHeight())
			Popup.Content:Size(250 - 2*self.BorderSize - 2*self.Padding, 20)

			Popup.AddRow = function(this,...)
				local newHeight = this.Content:AddRow(...)
				Popup:Size(nil,newHeight + 3*self.BorderSize + 5*self.Padding + this.Header:GetHeight())
				Popup.Content:Size(nil, newHeight + self.BorderSize + 2*self.Padding)
			end

			Popup.ChangeItem = function(this,...)
				Popup.Content:ChangeItem(...)
			end

		if type(Parent) == "string" then 
			PopupWindow = Popup
			Popup.OnCloseFunc = function()
				PopupWindowKey = nil
			end
		else 
			Parent.ConnectedPopup = Popup
		end

		return Popup
    end 
end