local UIParent, insert = UIParent, table.insert;

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:VerifyAction(Parent, Title, Text, AcceptFunc, CancelFunc)
    local VerifyWindow = self:CreateFrame(Parent)
    VerifyWindow:SetFrameStrata("Tooltip")
    VerifyWindow:SetThemedBackdrop()
    VerifyWindow:Size(250, 100)
    VerifyWindow:SetPoint("CENTER", UIParent)

    VerifyWindow.Header = self:CreateFrame(VerifyWindow)
    VerifyWindow.Header:SetPoint("TOPLEFT", self.BorderSize + self.Padding, -self.BorderSize - self.Padding)
    VerifyWindow.Header:SetPoint("TOPRIGHT", -self.BorderSize - self.Padding, -self.BorderSize - self.Padding)
    VerifyWindow.Header:Size(nil, 20)
    VerifyWindow.Header:SetThemedBackdrop()
    VerifyWindow.Header:SetText(Title)

    VerifyWindow.Accept = self:CreateButton(VerifyWindow)
    VerifyWindow.Accept:SetPoint("BOTTOMLEFT", self.BorderSize + self.Padding, self.BorderSize + self.Padding)
    VerifyWindow.Accept:SetPoint("BOTTOMRIGHT", VerifyWindow, "BOTTOM", -self.Padding / 2, self.BorderSize + self.Padding)
    VerifyWindow.Accept:Size(nil, 20)
    VerifyWindow.Accept:SetIcon("TexturePath",self:GetIcon("CheckMask"),"Red", 0.25,"Green", 1,"Blue", 0.25,"Rotation",-45,"LockAspectRatio",true,"HFlip",true,"Zoom",0.25);
    VerifyWindow.Accept.OnClick = function()
        VerifyWindow:Release()
        if AcceptFunc then
            AcceptFunc()
        end
    end

    VerifyWindow.Cancel = self:CreateButton(VerifyWindow)
    VerifyWindow.Cancel:SetPoint("BOTTOMRIGHT", -self.BorderSize - self.Padding, self.BorderSize + self.Padding)
    VerifyWindow.Cancel:SetPoint("BOTTOMLEFT", VerifyWindow, "BOTTOM", self.Padding / 2, self.BorderSize + self.Padding)
    VerifyWindow.Cancel:Size(nil, 20)
    VerifyWindow.Cancel:SetIcon("TexturePath",self:GetIcon("PlusMask"),"Red",1,"Green",0.25,"Blue",0.25,"Rotation",45,"LockAspectRatio",true,"Zoom",0.2);
    VerifyWindow.Cancel.OnClick = function()
        VerifyWindow:Release()
        if CancelFunc then
            CancelFunc()
        end
    end

    VerifyWindow.Content = self:CreateFrame(VerifyWindow)
    VerifyWindow.Content:SetPoint("TOPLEFT", VerifyWindow.Header, "BOTTOMLEFT", 0, -self.Padding)
    VerifyWindow.Content:SetPoint("BOTTOMRIGHT", VerifyWindow.Cancel, "TOPRIGHT", 0, self.Padding)
    VerifyWindow.Content:SetThemedBackdrop()
    VerifyWindow.Content:SetText(Text, 11, 1, 1, 1, "LEFT", "TOP")

    return VerifyWindow
end